/**@file
 *@brief	anthy-agentץȥʹؿRKѴϢ
 *@date		Wed,28 Aug,2013 - Mon,16 Sep,2013
 *@date		Mon,30 Sep,2013
 *@author	Copyright(C)2013 G-HAL, All rights reserved.
 *
 *@note
 *@verbatim
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

* Neither the name of the copyright holders nor the names of its contributors
may be used to endorse or promote products derived from this software
without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *@endverbatim
 */
#ifndef parseline_rk_h_included_
#define parseline_rk_h_included_

#if defined(HAVE_CONFIG_H)
# include "config.h"
#endif

#if !defined(__STDC_LIMIT_MACROS)
# define __STDC_LIMIT_MACROS
#endif
#if !defined(__STDC_CONSTANT_MACROS)
# define __STDC_CONSTANT_MACROS
#endif
#if defined(HAVE_STDINT_H)
# include <stdint.h>
#endif

#include "parseline_common.h"



#ifdef __cplusplus
extern "C" {
#endif



/** ޻- Ѵޥåסʥɵѡ */
struct rk_map_source_t {
	const char* const input;			/**< Ϥ줿ʸ */
	const char* const output;			/**< Ϥʸ */
	const char* const pending;			/**< ڥǥ󥰤ʸ */
};



/** ʸѴʤäΥʸ */
extern const char rk_GETA[];

/** ޻- Ѵޥåװ */
extern struct rk_map_tables_t rk_map_tables[];



extern size_t parseline_rk(struct agent_parser_context_transaction_t* const apct, char pending_str[], size_t maxlen_pending_str, string_internal_t* const output_str, char (*output_str_rk)[PENDING_BUFSIZE], size_t maxlen_output_str);
extern size_t parseline_rk_preedit(struct agent_parser_context_transaction_t* const apct, char preedit_str[], char pending_str[], size_t maxlen_pending_str, string_internal_t* const output_str, char* const output_rk_str, size_t maxlen_output_str);

extern bool parseline_rk_clear_map(struct rk_map_tables_t* const tbl);
extern bool parseline_rk_build_map(struct rk_map_tables_t* const tbl);

extern bool init_parser_rk(void);
extern bool fin_parser_rk(void);



#ifdef __cplusplus
}
#endif

#endif /* parseline_rk_h_included_ */
/* [ End of File ] */
